# -*- coding: euc-jp -*-
require "numru/ggraph"
include NumRu


#path  = "../mknc_dm1lst/out/MGS_SurfTemp_LST14_T21L32.nc"
#vname = "SurfTemp"
#iyrs = 5
#iyre = 5
#flag3d = false
#level = 0

#path  = "./mgs_tes_my26_season01.nc"
#path  = "/RAID0/yot/work/dataanalysis/chart/ncfiledir_dls5_dlon10_dlat5/mgs_tes_my26_season01.nc"
#vname = "ts_14lst"
#iyrs = 1
#iyre = 1
#flag3d = false
#level = 0

#path  = "../mknc_dm1lst/out/MGS_Temp_LST02_T21L32.nc"
#vname = "Temp"
#iyrs = 1
#iyre = 1
#flag3d = true
#level = 18
##level = 50
##level = 136
##level = 370

#path  = "/RAID0/yot/work/dataanalysis/chart/ncfiledir_dls5_dlon10_dlat5/mgs_tes_my26_season01.nc"
#vname = "t_02lst"
#iyrs = 1
#iyre = 1
#flag3d = true
#level = 0.18
##level = 0.50
##level = 1.36
##level = 3.70


path   = ARGV[0]
vname  = ARGV[1]
iyrs   = ARGV[2].to_i
iyre   = ARGV[3].to_i
if ARGV[4] == "true" then
  flag3d = true
else
  flag3d = false
end
level  = ARGV[5].to_f



# color map
#DCL.sgscmn(5)  # grey scale
#DCL.sgscmn(14) # blue-white-red

gphys = GPhys::NetCDF_IO.open(path, vname)


if flag3d == true then
  gphys = gphys.cut(gphys.axis(2).name=>level)
end

gphys_disp = gphys.copy

timedimname = gphys_disp.axis(2).name
#gphys_disp = gphys_disp.cut(timedimname=>(360*(iyrs-1))..(360*iyre))
gphys_disp = gphys_disp.cut(timedimname=>(0..(360*(iyre-iyrs+1))))

ls = gphys_disp.axis(timedimname).pos.val
ls = ls - 360*(iyrs-1)
gphys_disp.axis(timedimname).set_pos(VArray.new(ls,nil,"Ls"))

rmiss = gphys_disp.get_att('missing_value')[0]
DCL.glpset('lmiss',true)
DCL.glpset('rmiss',rmiss)


#DCL.gropn(1)
DCL.gropn(2)
#DCL.sldiv('y',2,2)
DCL.sgpset('lcntl', false)
DCL.sgpset('lfull',true)
DCL.uzfact(0.75)
DCL.sgpset('lfprop',true)

#GGraph.set_fig 'viewport'=>[0.15,0.85,0.2,0.6], 'window'=>[ls[0],ls[ls.shape[0]-1],-90,90]
GGraph.set_fig 'viewport'=>[0.15,0.85,0.2,0.6], 'window'=>[0,(iyre-iyrs+1)*360,-90,90]
GGraph.set_axes('xlabelint'=>90)
GGraph.set_axes('ylabelint'=>30)

#gphys_disp = gphys_disp - 1.0e-3
gphys_disp = gphys_disp.mean('lon')

if vname == 'VIH2OVap'
  # conversion from kg m-2 to precipitable micron
  gphys_disp = gphys_disp / 1.0e3 * 1.0e6
end

if vname == 'DOD067' then
  levels = [0  ,0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,
            1.0,1.1,1.2,1.3,1.4,1.5,1.6]
  patterns = [10999,15999,20999,25999,30999,35999,40999,45999,50999,55999,
              60999,65999,70999,75999,80999,85999,90999,95999]
elsif vname == 'DustMaxHeight' then
  levels = [ 5e3,10e3,15e3,20e3,25e3,30e3,35e3,40e3,45e3,50e3,
            55e3,60e3,65e3,70e3,75e3,80e3,85e3]
  patterns = [10999,15999,20999,25999,30999,35999,40999,45999,50999,55999,
              60999,65999,70999,75999,80999,85999,90999,95999]
elsif vname == 'VIH2OVap'
  levels = [0,5,10,15,20,25,30,40,50,60,70,80,90,100]
  patterns = [10999,15999,20999,30999,35999,40999,45999,60999,70999,75999,80999,85999,90999,95999]
elsif vname == 'VIH2OSol'
  levels = [0,0.025,0.05,0.075,0.10,0.125,0.15,0.175,0.20,0.25,0.30,0.35,0.40]
  patterns = [10999,15999,20999,30999,35999,40999,45999,60999,70999,75999,80999,85999,90999,95999]
elsif vname == 'VIH2OSolOD'
  levels = [0,0.025,0.05,0.075,0.10,0.125,0.15,0.175,0.20,0.25,0.30,0.35,0.40]
  patterns = [10999,15999,20999,30999,35999,40999,45999,60999,70999,75999,80999,85999,90999,95999]
else 
  levels = [140,150,160,170,180,190,200,210,220,230,
            240,250,260,270,280,290,300]
#  levels = [140,145,150,155,160,165,170,175,180,185,
#            190,195,200,205,210,215,220]
  patterns = [10999,15999,20999,25999,30999,35999,40999,45999,50999,55999,
              60999,65999,70999,75999,80999,85999,90999,95999]
end

if vname[0..4] == 'VIH2O' 
  gphys_disp.long_name = ""
end


GGraph.tone( gphys_disp, true, 'lev'=>levels, 'pat'=>patterns, 'annotate'=>false, 'exchange'=>true )

#GGraph.tone( gphys_disp, true, 'annotate'=>false, 'exchange'=>true )

GGraph.color_bar

#DCL::uxmttl('T', ' ', 1.0)
#DCL::uxmttl('T', title, -1.0)


DCL.grcls

