require "numru/ggraph"
require "./gphys_const_v1.2"
require './gphys_methods_v1.91'
include NumRu
include NMath

#dir = ARGV[0]
#iyrs = ARGV[1].to_i
#iyre = ARGV[2].to_i
#gcmzsfn    = ARGV[3]
#gcmzsvname = ARGV[4]
#obslon = ARGV[5].to_f
#obslat = ARGV[6].to_f
#obsfn  = ARGV[7]
#obsvname = ARGV[8]
#obszs  = ARGV[9].to_f

ncfn = ARGV[0]
gcmvname = ARGV[1]
iyrs = ARGV[2].to_i
iyre = ARGV[3].to_i
hemisphere = ARGV[4]
obslon = ARGV[5].to_f
obslat = ARGV[6].to_f
obsfn  = ARGV[7]
obsvname = ARGV[8]


gphysw = GPhys::NetCDF_IO.open( ncfn, 'lat_weight')
weight = gphysw.val
weight = weight / weight.sum(0)
lat = GPhys::NetCDF_IO.open( ncfn, 'lat').val
if hemisphere == 'south' then
  weight[ (lat.gt -75.0) ] = 0.0
elsif hemisphere == 'north' then
  weight[ (lat.lt  75.0) ] = 0.0
else
  print 'Unexpected hemisphere: ' + hemisphere + '\n'
  exit
end

basels = 360*(iyrs-1)+135
gphys = GPhys::NetCDF_IO.open( ncfn, gcmvname )
gphys = gphys.cut('PlanetLonFromVE'=>360*(iyrs-1)..360*iyre)

baseval = gphys.cut('lon'=>obslon).cut('lat'=>obslat).cut('PlanetLonFromVE'=>basels).val[0]
gphys = gphys / baseval

print "Value at (lon,lat,Ls) (", obslon, ",", obslat, ",", basels, ") = ", baseval, "\n"

fileunit = File.open("ar_vl2.txt", 'w')
fileunit.puts 'Value at (lon,lat,Ls)=('+obslon.to_s+','+obslat.to_s+','+basels.to_s+')='+baseval.to_s+'  :   '+0.0145.to_s
fileunit.close

# I want to calculate weighted average of Argon mixing ratio in high latitude.
# In order to do that, in general, I calculate sum of values times weights
# and divide it by sum of weights. But, I cannot find a good method to do that
# by using ruby and GPhys.
# So, I calculate weights divided by sum of weights, then, I calculate sum of
# values times the weights (divided by sum of weights). 
weight = weight / weight.sum
gphys = ( gphys * weight.reshape!(1,gphysw.shape[0]) ).sum('lat').mean('lon')

#p weight.sum(0)[0]
#p gphys.val
#for j in 0..(weight.size-1)
#  p weight[j]
#end

gphysls = gphys.coord('PlanetLonFromVE')
ls = gphysls.val % 360
replace_axis( 'ls',
              'Ls',
              'Ls', #gphysls.get_att('units'),
              ls,
              'PlanetLonFromVE',
              gphys )

gphys.units = '1'
gphys.long_name = 'Ar EF'

# Reading observed surface pressure
gphysobs = GPhys::NetCDF_IO.open(obsfn, obsvname)


## Change time axis (model)
#gphysls = GPhys::NetCDF_IO.open(dir+'/'+vnamels+"_rank000000.nc", vnamels)
#gphysls = gphysls.cut('time'=>times..timee)
#
#replace_axis( 'ls',
#              gphysls.get_att('long_name'),
#              gphysls.get_att('units'),
#              gphysls.val,
#              'time',
#              gphysps )
#
## modify ls axis (observation)
#ls = gphysobs.coord('ls').val % 360
#replace_axis( 'ls',
#              gphysls.get_att('long_name'),
#              gphysls.get_att('units'),
#              ls,
#              'ls',
#              gphysobs )

#DCL.gropn(1)
DCL.gropn(2)
#if ARGV.index("-ps")
#  DCL::gropn(2)
#else
#  DCL::gropn(1)
#end
#DCL.sldiv('y',3,3)
DCL.sgpset('lcntl', false)
DCL.sgpset('lfull',true)
#DCL.uzfact(0.75)
DCL.sgpset('lfprop',true)

#GGraph.set_fig('viewport'=>[0.15,0.7,0.2,0.6])

if hemisphere == 'south' then
  y1 =  0.0
  y2 = 10.0
elsif hemisphere == 'north' then
  y1 = -1.0
  y2 = 10.0
else
  print 'Unexpected hemisphere: ' + hemisphere + '\n'
  exit
end
GGraph.set_fig 'viewport'=>[0.15,0.7,0.2,0.6], 'window'=>[0,360,y1,y2]

GGraph.set_axes('xlabelint'=>90)

#GGraph.line( gphysps, true )
GGraph.mark( gphys, true, 'annotate'=>false )
GGraph.mark( gphysobs, false, 'index'=>21 )

DCL.grcls

